/*
 * xdraw3.c  Combining Xlib drawing with widget.  Shows keyboard and mouse input.
 * Stop it by typing q.
 * Wm. Randolph Franklin
 * Last modified: Mon Nov  4 17:24:16 EST 1991
 * Compile with -lXaw -lXmu -lXt -lX11.
 */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <time.h>

#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>

#define PI 3.1416

Atom DISPLAY_DATA;
Atom DISPLAY_TYPE;
typedef struct {
		int ny;
		float y[1000];
	       }	display_data;

#define NPOINTS 5
XPoint  points[NPOINTS] =
{50, 50, 650, 50, 650, 650, 50, 650, 50, 50};
XRectangle  s_carb[100000], carb[100000], hyd[100000]; 

Display *display;
Window  window;
GC      gc, gc_yellow_dash, gc_orange, gc_green, gc_red, gc_yellow, gc_blue;
Font    font;
int     s_carb_count = 0;
int     carb_count = 0;
int     hyd_count = 0;
int     animate = 0;
int     key_count = 0;

void error_exit(char *s)
 {
  printf("\nERROR: %s -bye!\n",s);
  exit(1);
 }

void create_atoms(w)
    Widget w;
{
 Display * dpy = XtDisplay(w);

  DISPLAY_DATA = XInternAtom(dpy, "a_display_data", 0);

  DISPLAY_TYPE = XInternAtom(dpy, "a_display_type", 0);
}

void 
Redraw(w, event)
    Widget  w;
    XExposeEvent *event;
{				/* Called when window exposed */

    XDrawLines(display, window, gc,			/* Draw frame */
	       points, NPOINTS,
	       CoordModeOrigin);


    if (s_carb_count)
      XFillRectangles(display, window, gc,			/* Redraw curve */
	              s_carb, s_carb_count);
	         

    if (carb_count)
      XFillRectangles(display, window, gc_blue,                   /* Redraw curve */
                      carb, carb_count);

    if (hyd_count)
      XFillRectangles(display, window, gc_red,                   /* Redraw curve */
                      hyd, hyd_count);

}


void 
Buttonpress(w, event)
    Widget  w;
    XButtonEvent *event;
{
 int row, col, rateC, rateH, count[100];
 register int h, l;
 int j, k, run_num, c, three_below;
 int count1, count2, center_col, flag, boundary;
 int radnum1, radnum2, trans_row, trans_col;
 static int grid[300][300], height[300], col_count[300];
 int diff, runs, sum, max, min, num;
 static int dead[10000], list[100000][3], last_pos;
 float ave, ave_height_den;
 char output, name[30], substrate;
 FILE *temp;

 printf("\nType s if output is to go to screen or f for file:");
 scanf("%s",&output);

   if(output == 's')
     temp = stdout;
   else if(output == 'f')
    {
     printf("Enter name of file:");
     scanf("%s",&name);
     temp = fopen(name,"w");
    }
   else
     error_exit("Enter only s or f please");

 printf("Enter the g for graphite substrate of d for diamond substrate:");
 scanf("%s",&substrate);

   if(!(substrate == 'g' || substrate == 'd'))
     error_exit("Enter only g or d please");

 printf("Enter height of grid (integer value < 300):");
 scanf("%d",&row);

  trans_row = (int)((700-(4*row))/2);

 printf("Enter width of grid (integer value < 135):");
 scanf("%d",&col);

  trans_col =(int)((700-(4*col))/2);

 printf("Enter rate at which carbon atoms are deposited (integer value):");
 scanf("%d",&rateC);

 printf("Enter rate at which hydrogen atoms are (integer value):");
 scanf("%d",&rateH);

 printf("Enter 1 for periodic boundary conditions and 0 for regular boundary conditions:");
 scanf("%d",&boundary);

   if(!(boundary == 1 || boundary == 0))
     error_exit("Enter 1 or 0 only please");

 printf("Enter number of trials (integer value):");
 scanf("%d",&runs);

 printf("\n");

/* Seed function used to seed random number function */

 srand((unsigned)time(NULL));

  for(h = 0;h < row;h++)
    *(height+h) = 0;

 for(run_num = 0;run_num < runs;run_num++)
  {
   *(count+run_num) = 0;
   last_pos = 0;
   flag = 1;

   for(h = 0;h < (row + 2);h++)
     for(l = 0;l < (col + 2);l++)
       *(*(grid+h)+l) = 0;

    if(substrate == 'g')
      for(h = 0;h < (col + 2);h++)
       {
        *(*(grid+row)+h) = 3;
        *(col_count+h) = 0;
       }
    else if(substrate == 'd')
     {
      for(h = 0;h < (col + 2);h += 2)
        {
         *(*(grid+row)+h) = 3;
         *(col_count+h) = 0;
        }
      for(h = 1;h < (col + 2);h += 2)
        {
         *(*(grid+row+1)+h) = 3;
         *(col_count+h) = 0;
        }
     }

   count1 = rateC;
   count2 = rateH;

   do
   {

    if(count1 == rateC)
     {
      radnum1 = rand()%col + 1;
      *(*(grid)+radnum1) = 2;
      *(*(list+last_pos)) = radnum1;
      *(*(list+last_pos)+1) = 0;
      last_pos++;
      count1 = 0;
     }

    if(count2 == rateH)
     {
      radnum2 = rand()%col + 1;
      diff = (radnum2 - radnum1);
      if(count1 == 0 && diff >= -1 && diff <= 1)
       {
        *(*(grid)+radnum1) = 0;
        last_pos--;
       }
      else
       {
        *(*(grid)+radnum2) = -1;
        *(*(list+last_pos)) = radnum2;
        *(*(list+last_pos)+1) = 0;
        last_pos++;
       }
      count2 = 0;
     }

     count1++;
     count2++;

     num = 0;

          for(c = 0;c < last_pos;c++)
          {

           j = *(*(list+c)+1);
           k = *(*(list+c));

             if(k == 1 && boundary == 1)
              {
               for(h = 0;h < row;h++)
                  *(*(grid+h)) = *(*(grid+h)+col);
              }
             else if(k == col && boundary == 1)
              {
               for(h = 0;h < row;h++)
                 *(*(grid+h)+(col+1)) = *(*(grid+h)+1);
              }

           three_below = ((*(*(grid+j+1)+k-1)) + (*(*(grid+j+1)+k)) +  (*(*(grid+j+1)+k+1)));

             if(three_below == 0)
              {
               *(*(grid+j+1)+k) = *(*(grid+j)+k);
               *(*(grid+j)+k) = 0;
               *(*(list+c)+1) = j+1;
              }
             else
              {
                 if(*(*(grid+j)+k) == 2)
                  {
                    if(three_below > 3)
                     {
                      *(*(grid+j)+k) = 3;
                      (*(col_count+k))++;

                      if(three_below == 4)
                       {
                        *(*(grid+(j+1))+(k+1)) = 3;
                        *(*(grid+(j+1))+(k-1)) = 3;
                        (*(col_count+(k+1)))++;
                        (*(col_count+(k-1)))++;
                       }
                      else if(three_below == 5)
                       {
                         if(*(*(grid+(j+1))+(k+1)) == 2)
                          {
                           *(*(grid+(j+1))+(k+1)) = 3;
                           (*(col_count+(k+1)))++;
                          }
                         else
                          {
                           *(*(grid+(j+1))+(k-1)) = 3;
                           (*(col_count+(k-1)))++;
                          }
                       }
                     }
                     if(j == 0)
                      {
                       flag = 0;
                       break;
                      }

                   *(dead+num) = c;
                   num++;
                  }
                 else
                  {

                   *(*(grid+j)+k) = 0;
                   *(dead+num) = c;
                   num++;

                    if(three_below == 2)
                     {
                        if(*(*(grid+j+1)+k-1) == 2)
                          center_col = k-1;
                        else if(*(*(grid+j+1)+k) == 2)
                          center_col = k;
                        else
                          center_col = k+1;

                      sum = 0;

                        for(h = j;h < (j+3);h++)
                           for(l = (center_col-1);l < (center_col+2);l++)
                               sum += *(*(grid+h)+l);

                        if(sum <= 5)
                          *(*(grid+(j+1))+center_col) = 0;
                     }
                    else if(three_below == 4)
                     {
                      if((rand()%2 + 1) == 2)
                        *(*(grid+(j+1))+(k-1)) = 0;
                      else
                        *(*(grid+(j+1))+(k+1)) = 0;
                     }
                    else if(three_below == 5)
                     {
                      if(*(*(grid+(j+1))+(k+1)) == 2)
                        *(*(grid+(j+1))+(k+1)) = 0;
                      else
                        *(*(grid+(j+1))+(k-1)) = 0;
                     }
                 }
            }

             if(k == 1 && boundary == 1)
              {
               for(h = 0;h < row;h++)
                  *(*(grid+h)+col) = *(*(grid+h));
              }
             else if(k == col && boundary == 1)
              {
               for(h = 0;h < row;h++)
                 *(*(grid+h)+1) = *(*(grid+h)+(col+1));
              }

      }
     if(animate)
      {
       s_carb_count = 0;
       carb_count = 0;
       hyd_count = 0;

       for(h = 0;h < row;h++)
         {
          for(l = 1;l < (col + 1);l++)
            {
             if(grid[h][l] == 2)
              {
               carb[carb_count].x = 4*l + trans_col;
               carb[carb_count].y = 4*h + trans_row;
               carb[carb_count].width = 4;
               carb[carb_count].height = 4;
               carb_count++;
              }              
             else if(grid[h][l] == -1)
              {
               hyd[hyd_count].x = 4*l + trans_col;
               hyd[hyd_count].y = 4*h + trans_row;
               hyd[hyd_count].width = 4;
               hyd[hyd_count].height = 4;
               hyd_count++;
              }
             else if(grid[h][l] == 3)
              {
               s_carb[s_carb_count].x = 4*l + trans_col;
               s_carb[s_carb_count].y = 4*h + trans_row;
               s_carb[s_carb_count].width = 4;
               s_carb[s_carb_count].height = 4;
               s_carb_count++;
              }
           }
        }
 
           XClearArea(display,window,51,51,545,545,FALSE);

	    if (s_carb_count)
      		XFillRectangles(display, window, gc,                      /* Redraw curve */
 	                        s_carb, s_carb_count);


 	   if (carb_count)
      		XFillRectangles(display, window, gc_blue,                   /* Redraw curve */
                                carb, carb_count);

 	   if (hyd_count)
      		XFillRectangles(display, window, gc_red,                   /* Redraw curve */
                   	        hyd, hyd_count);
     }                    

    for(h = (num-1);h > -1;h--)
     {
         for(l = *(dead+h);l <= (last_pos-1);l++)
          {
           *(*(list+l)) = *(*(list+l+1));
           *(*(list+l)+1) = *(*(list+l+1)+1);
          }
         last_pos--;
     }

   }
   while(flag);


       s_carb_count = 0;
       carb_count = 0;
       hyd_count = 0;

       for(h = 0;h < row;h++)
         {
          for(l = 1;l < (col + 1);l++)
            {
             if(grid[h][l] == 2)
              {
               carb[carb_count].x = 4*l + trans_col;
               carb[carb_count].y = 4*h + trans_row;
               carb[carb_count].width = 4;
               carb[carb_count].height = 4;
               carb_count++;
              }
             else if(grid[h][l] == -1)
              {
               hyd[hyd_count].x = 4*l + trans_col;
               hyd[hyd_count].y = 4*h + trans_row;
               hyd[hyd_count].width = 4;
               hyd[hyd_count].height = 4;
               hyd_count++;
              }
             else if(grid[h][l] == 3)
              {
               s_carb[s_carb_count].x = 4*l + trans_col;
               s_carb[s_carb_count].y = 4*h + trans_row;
               s_carb[s_carb_count].width = 4;
               s_carb[s_carb_count].height = 4;
               s_carb_count++;
              }
           }
        }

           XClearArea(display,window,51,51,545,545,FALSE);

            if (s_carb_count)
                XFillRectangles(display, window, gc,                      /* Redraw curve */
                                s_carb, s_carb_count);


           if (carb_count)
                XFillRectangles(display, window, gc_blue,                   /* Redraw curve */
                                carb, carb_count);


           if (hyd_count)
                XFillRectangles(display, window, gc_red,                   /* Redraw curve */
                                hyd, hyd_count);

   fprintf(temp,"Trial number %d:\n\n",run_num+1);


   for(h = 0;h < row + 2;h++)
     {
      fprintf(temp,"%4d     ",h+1);

      for(l = 1;l < (col + 1);l++)
       {
        if(*(*(grid+h)+l) == 2)
          {
           fprintf(temp,"C");
           (*(count+run_num))++;
           (*(height+h))++;
          }
        else if(*(*(grid+h)+l) == -1)
          fprintf(temp,"H");
        else if(*(*(grid+h)+l) == 3)
          {
           fprintf(temp,"X");
           (*(count+run_num))++;
           (*(height+h))++;
          }
        else
          fprintf(temp,".");
       }

      fprintf(temp,"\n");
     }

    fprintf(temp,"\nNumber of cells on is %d\n\n",*(count+run_num));

  }

  max = *(count);
  min = *(count);

    for(h = 1;h < runs;h++)
     {
      if(*(count+h) > max)
        max  = *(count+h);
      if(*(count+h) < min)
        min = *(count+h);
     }

  fprintf(temp,"Maximum number of cells on in any one run was %d\n",max);
  fprintf(temp,"Minimum number of cells on in any one run was %d\n",min);

  sum = 0;

    for(h = 0;h < runs;h++)
      sum += *(count+h);

  ave = ((float)sum/(float)runs);

  fprintf(temp,"Average number of cells on after %d runs is %f\n",runs,ave);

/* Average density was calculated by dividing the average number of cells that remained "on"
   after a certain number of trials by the total number of cells in the grid.
*/

  fprintf(temp,"Average density of cells that are on is %f percent\n\n",(ave/(float)(row*col))*100.0);

  fprintf(temp,"Average number of cells that are on in each row are:\n\n");

  for(h = 0;h < row;h++)
   {
    ave_height_den = ((float)(*(height+h))/(float)runs);
    fprintf(temp,"%4d  ->  %f\n",h+1,ave_height_den);
   }

  fprintf(temp,"\nNumber of stable carbon atoms in each column\n");

  for(h = 1;h < (col + 1);h++)
    fprintf(temp,"%4d  -> %d\n",h,*(col_count+h));

  printf("DONE!\n");

  if(output == 'f')
    fclose(temp);
}

void
Keypress(w, event)              /* Processes a keypress event */
    Widget  w;
    XKeyEvent *event;
{
  if(key_count)
   {
    animate = 0;
    key_count = 0;
    printf("Animate off\n");
   }
  else
   {
    animate = 1;
    key_count++;
    printf("Animate on\n");
   }
}


main(argc, argv)
    int     argc;
    char  **argv;
{
    int     screen;		/* screen is an int                 */
    unsigned long black, white;
    XEvent  event;
    Window      root;
    int     i, done;
    Colormap cmap;
    XColor  yellow, orange, green, red, blue;
    Widget  topLevel, framework, widget, command;
    Arg     arg[5];

    static XtActionsRec actions[] = {{"redraw", Redraw},
    {"keypress", Keypress},
    {"buttonpress", Buttonpress}};

    topLevel = XtInitialize(
			    argv[0],	/* application name */
			    "XDraw",	/* application class name */
			    NULL,	/* application resources (not used) */
			    0,	/* application resource count */
			    &argc,	/* command line argument count */
			    argv);	/* command-line string */

    root =  DefaultRootWindow(XtDisplay(topLevel));

  /*
   * Initialize the Atoms used for the properties.
   */
    create_atoms(topLevel);

    framework = XtCreateManagedWidget("framework",
				       xmFormWidgetClass,
				       topLevel, NULL, 0);

/*  Create the column to hold the quit button
*/
    i = 0;
    XtSetArg(arg[i], XtNbackground, 1);
    i++;
    command = XtCreateManagedWidget("command",
				    xmRowColumnWidgetClass,
				    framework, arg, i); 


    i = 0;
    XtSetArg(arg[i], XtNwidth, 700);
    i++;			/* Create widget with a certain size */
    XtSetArg(arg[i], XtNheight, 700);
    i++;
    XtSetArg(arg[i], XtNbackground, 1);
    i++;
    widget = XtCreateManagedWidget("widget", widgetClass, framework,
				   arg, i);

    XtOverrideTranslations(widget,
			   XtParseTranslationTable("<Expose>: redraw()\n\
                                                    <KeyPress>: keypress()\n\
                                                    <ButtonPress>: buttonpress()"));

    display = XtDisplay(widget);

    screen = XDefaultScreen(display);

    black = XBlackPixel(display, screen);	/* Don't assume black=0 and white=1 */
    white = XWhitePixel(display, screen);

    cmap = XDefaultColormap(display, screen);
    yellow.red = (yellow.green = 65535);
    yellow.blue = 0;
    orange.red = 65535;
    orange.green = 32768;
    orange.blue = 0;
    green.red = green.blue = 0;
    green.green = 65535;
    red.red = 65535;
    red.green = red.blue = 0;

    if (DefaultDepth(display, screen) == 1) {
	printf("Screen has depth one.  Lotsa luck showing colors\n");
	yellow.pixel = orange.pixel = green.pixel = white;
	red.pixel = black;

    } else {			/* These set the pixel field with the color id */
	if (XAllocColor(display, cmap, &yellow) == 0 ||
	    XAllocColor(display, cmap, &orange) == 0 ||
	    XAllocColor(display, cmap, &red) == 0 ||
            XAllocColor(display, cmap, &blue) == 0 ||
	    XAllocColor(display, cmap, &green) == 0) {
	    printf("Can't do colors\n");
	    exit(3);
	}
    }

    XtAddActions(actions, 3);
  /*
   * Request property change event for the ROOT window.
   */
    XSelectInput(XtDisplay(topLevel), root, PropertyChangeMask);

    XtRealizeWidget(topLevel);

    window = XtWindow(widget);	/* no window until realized */

    gc = XCreateGC(display, window, 0, 0);	/* an attribute bundle */
    XSetForeground(display, gc, black);	/* must be explicit */
    XSetBackground(display, gc, white);

    font = XLoadFont(display,"rom17");
    XSetFont(display,gc,font);

    gc_yellow_dash = XCreateGC(display, window, 0, 0);	/* another bundle */
    XSetForeground(display, gc_yellow_dash, yellow.pixel);	/* must be explicit */
    XSetBackground(display, gc_yellow_dash, red.pixel);

    XSetLineAttributes(display, gc_yellow_dash, 0, LineDoubleDash, CapRound, JoinBevel);

    gc_orange = XCreateGC(display, window, 0, 0);
    XSetForeground(display, gc_orange, orange.pixel);

    gc_green = XCreateGC(display, window, 0, 0);
    XSetForeground(display, gc_green, green.pixel);

    gc_red = XCreateGC(display, window, 0, 0);
    XSetForeground(display, gc_red, red.pixel);

    gc_yellow = XCreateGC(display, window, 0, 0);
    XSetForeground(display, gc_yellow, yellow.pixel);

    gc_blue = XCreateGC(display, window, 0, 0);
    XSetForeground(display, gc_blue, 11);
    
    while(TRUE)
     {
      XtNextEvent(&event); 
      XtDispatchEvent(&event);
     }
}


